blob: d1f7b0d6be66da15585058dfbdbca4a7b13378ac [file] [log] [blame]
Emese Revfy6b90bd42016-05-24 00:09:38 +02001ifdef CONFIG_GCC_PLUGINS
2 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
3 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
4
Emese Revfy543c37c2016-05-24 00:11:37 +02005 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
6
Emese Revfy0dae7762016-05-24 00:10:35 +02007 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
Emese Revfy543c37c2016-05-24 00:11:37 +02008
Emese Revfy38addce2016-06-20 20:41:19 +02009 gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
10 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
Andrew Donnellan7b4010e2016-12-06 17:27:58 +110011 ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
Emese Revfy38addce2016-06-20 20:41:19 +020012 DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
13 endif
14
Emese Revfy543c37c2016-05-24 00:11:37 +020015 ifdef CONFIG_GCC_PLUGIN_SANCOV
16 ifeq ($(CFLAGS_KCOV),)
17 # It is needed because of the gcc-plugin.sh and gcc version checks.
18 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
19
20 ifneq ($(PLUGINCC),)
21 CFLAGS_KCOV := $(SANCOV_PLUGIN)
22 else
23 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
24 endif
25 endif
26 endif
27
Kees Cookc61f13e2017-01-13 11:14:39 -080028 gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so
29 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose
Ard Biesheuvelf7dd2502017-08-06 12:06:27 +010030 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_BYREF_ALL) += -fplugin-arg-structleak_plugin-byref-all
Kees Cookc61f13e2017-01-13 11:14:39 -080031 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN
32
Kees Cook313dd1b62017-05-05 23:37:45 -070033 gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so
34 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN
35 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
36
Emese Revfy65d59ec2016-06-20 20:40:24 +020037 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
Emese Revfy6b90bd42016-05-24 00:09:38 +020038
Emese Revfy38addce2016-06-20 20:41:19 +020039 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
40 export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
Emese Revfy6b90bd42016-05-24 00:09:38 +020041
Kees Cooked58c0e2016-06-17 23:11:12 -070042 ifneq ($(PLUGINCC),)
Emese Revfy543c37c2016-05-24 00:11:37 +020043 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
44 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
Emese Revfy6b90bd42016-05-24 00:09:38 +020045 endif
46
47 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
48 GCC_PLUGIN := $(gcc-plugin-y)
Emese Revfycaefd8c2016-06-26 17:38:20 +020049 GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
Emese Revfy6b90bd42016-05-24 00:09:38 +020050endif
Kees Cooked58c0e2016-06-17 23:11:12 -070051
52# If plugins aren't supported, abort the build before hard-to-read compiler
53# errors start getting spewed by the main build.
54PHONY += gcc-plugins-check
55gcc-plugins-check: FORCE
56ifdef CONFIG_GCC_PLUGINS
57 ifeq ($(PLUGINCC),)
58 ifneq ($(GCC_PLUGINS_CFLAGS),)
Andrew Donnellan65c059bc2016-12-06 17:28:00 +110059 # Various gccs between 4.5 and 5.1 have bugs on powerpc due to missing
60 # header files. gcc <= 4.6 doesn't work at all, gccs from 4.8 to 5.1 have
61 # issues with 64-bit targets.
62 ifeq ($(ARCH),powerpc)
63 ifeq ($(call cc-ifversion, -le, 0501, y), y)
64 @echo "Cannot use CONFIG_GCC_PLUGINS: plugin support on gcc <= 5.1 is buggy on powerpc, please upgrade to gcc 5.2 or newer" >&2 && exit 1
65 endif
66 endif
Kees Cooked58c0e2016-06-17 23:11:12 -070067 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
68 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
69 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
70 else
71 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
72 endif
73 endif
74 endif
75endif
76 @:
77
78# Actually do the build, if requested.
79PHONY += gcc-plugins
80gcc-plugins: scripts_basic gcc-plugins-check
81ifdef CONFIG_GCC_PLUGINS
82 $(Q)$(MAKE) $(build)=scripts/gcc-plugins
83endif
84 @: